<template>
  <v-container>
    <v-row class="text-center">
      <v-col class="mb-4">
        <h2 class="display-2 font-weight-bold mb-3">Ontologies</h2>
      </v-col>
    </v-row>
    <v-card :v-show="ontologies.length > 0">
      <v-card-title>
        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          append-outer-icon="mdi-reload"
          @click:append-outer="reFetch"
          label="Search"
          single-line
        />
      </v-card-title>
      <v-data-table
        :headers="headers"
        :items="ontologies"
        :search="search"
        :items-per-page="20"
        :footer-props="{
          showFirstLastPage: true,
          itemsPerPageOptions: [10, 20, 40, 80, -1],
        }"
      >
        <template v-slot:item.status="{ item }">
          <v-tooltip top v-if="item.status === 'ERROR'">
            <template v-slot:activator="{ on, attrs }">
              <div class="inline">
                <span>{{ item.status }}</span>
                <v-icon
                  size="20"
                  :dark="$vuetify.theme.dark"
                  v-bind="attrs"
                  v-on="on"
                  style="margin-left: 4px"
                >
                  info
                </v-icon>
              </div>
            </template>
            <span
              >Ontology file could not be loaded or it <br />could not be parsed
              using ontospy (v1.9.9.2)</span
            >
          </v-tooltip>
          <span v-else>{{ item.status }}</span>
        </template>
      </v-data-table>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import Vue from "vue";
import {
  dispatchGetDomains,
  dispatchGetOntologies,
} from "@/store/main/actions";
import { readDomains, readOntologies } from "@/store/main/getters";
import { commitSetOntologies } from "@/store/main/mutations";

export default Vue.extend({
  name: "Ontologies",
  mounted() {
    if (readOntologies(this.$store).length == 0) {
      dispatchGetOntologies(this.$store);
    }
    if (readDomains(this.$store) == null) {
      dispatchGetDomains(this.$store);
    }
  },
  computed: {
    ontologies: function () {
      return readOntologies(this.$store);
    },
  },
  methods: {
    reFetch: function () {
      commitSetOntologies(this.$store, []);
      dispatchGetOntologies(this.$store);
    },
  },
  data: () => {
    return {
      search: "",
      headers: [
        {
          text: "Id",
          align: "start",
          filterable: false,
          value: "id",
        },
        { text: "Domain", value: "domain" },
        { text: "Name", value: "name" },
        { text: "Status", value: "status" },
        { text: "URL", value: "url" },
        { text: "Active", value: "active" },
      ],
    };
  },
});
</script>
